//Version 1.1
var eplFormats = {
    bannerGenerico: "bannerGenerico",
    bannerSkin: "bannerSkin",
    layerGenerico: "layerGenerico",
    bannerLayer: "bannerLayer",
    layerBoton: "layerBoton",
    layerScroll: "layerScroll",
    anuncioPrevio: "anuncioPrevio",
    unionLayers: "unionLayers",
    expandibleMultiple: "expandibleMultiple",
    folding: "folding",
    expandiblePush: "expandiblePush",
    expandibleRollover: "expandibleRollover",
    takeover: "takeover",
    zocalo: "zocalo",
    tripleImpacto: "tripleImpacto",
    multipleImpacto: "multipleImpacto",
    quintupleImpacto: "quintupleImpacto",
    inline: "inline"
};

function eplBuilder() {

    //FORMATOS - comienzo
    function Ad() {
        this.videoCount = 0;
        this.videos = [];
        this.isComplete = false;
    }
    Ad.prototype.getBannerId = function () {
        if (typeof bannerId !== "undefined") {
            return bannerId;
        } else {
            console.log("Error: la variable bannerId no esta definida");
            return;
        }
    };
    Ad.prototype.adComplete = function () {
        console.log("anuncio Completo [Ad]");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
        this.isComplete = true;
    };
    Ad.prototype.adCustomAction = function (id) {
        console.log("accion custom [" + id + "]");
        parent.eplDoc.eplTH.customAction(this.getBannerId(), id);
    };
    Ad.prototype.adStartTimer = function () {
        console.log("anuncio encendido");
        parent.eplDoc.eplTH.timerStart(this.getBannerId());
    };
    Ad.prototype.adStopTimer = function () {
        console.log("anuncio apagado");
        parent.eplDoc.eplTH.timerStop(this.getBannerId());
    };
    Ad.prototype.setVideo = function (vid) {
        var v = document.getElementById(vid);
        var c = this.isComplete;
        if (this.videoCount > 4) {
            console.log("máximo videos soportados 5");
            return;
        } else {
            this.videos[this.videoCount] = v;
            this.videoCount++;
        }
        v.onplay = function () {
            if (!c) {
                console.log("video play " + v.id);
                parent.eplDoc.eplTH.start(Ad.prototype.getBannerId());
            } else {
                console.log("video replay " + v.id);
                parent.eplDoc.eplTH.restart(Ad.prototype.getBannerId());
            }

        };

        v.onpause = function () {
            console.log("video pause " + v.id);
            parent.eplDoc.eplTH.stop(Ad.prototype.getBannerId());
        };

        v.onended = function () {
            if (!c) {
                c = true;
                Ad.prototype.adComplete();
            }
        };

        v.onvolumechange = function () {
            if (v.muted) {
                console.log("video volume off " + v.id);
                parent.eplDoc.eplTH.soundOff(Ad.prototype.getBannerId());
            } else if (v.volume > 0) {
                console.log("video volume on " + v.id);
                parent.eplDoc.eplTH.soundOn(Ad.prototype.getBannerId());
            }
        };
    };
    Ad.prototype.getVideo = function (vNumber) {
        return this.videos[vNumber];
    };

    //Banner Generico
    function BannerGenerico() {
    }
    BannerGenerico.prototype = new Ad();

    //Banner con Skin
    function BannerSkin() {

    }
    BannerSkin.prototype = new Ad();
    BannerSkin.prototype.adShowSkin = function (id, fixed) {
        if (fixed) {
            parent.document.body.style['background-attachment'] = 'fixed';
        } else {
            parent.document.body.style['background-attachment'] = 'scroll';
        }
        console.log("show skin :" + id + " type: " + parent.document.body.style['background-attachment'] + " [Banner con Skin]");
        parent.eplShowSkin(this.getBannerId(), id);
    };

    //Layer Generico
    function LayerGenerico() {

    }
    LayerGenerico.prototype = new Ad();
    LayerGenerico.prototype.adComplete = function () {
        console.log("anuncio Completo [Layer Generico]");
        parent.eplHideLayer(this.getBannerId(), 1);
    };
    LayerGenerico.prototype.adClose = function () {
        console.log("cerrar anuncio [Layer Generico]");
        parent.eplHideLayer(this.getBannerId());
    };

    //Banner a Layer
    function BannerLayer() {

    }
    BannerLayer.prototype = new Ad();
    BannerLayer.prototype.adComplete = function () {
        console.log("anuncio Completo [Banner a Layer]");
        parent.eplAMB2LHideLayer(this.getBannerId(), 1);
    };
    BannerLayer.prototype.adClose = function () {
        console.log("cerrar anuncio [Banner a Layer]");
        parent.eplAMB2LHideLayer(this.getBannerId());
    };
    BannerLayer.prototype.adExpand = function () {
        console.log("expandir anuncio [Banner a Layer]");
        parent.eplAMB2LShowLayer(this.getBannerId());
    };

    //Layer a Boton
    function LayerBoton() {

    }
    LayerBoton.prototype = new Ad();
    LayerBoton.prototype.adComplete = function () {
        console.log("anuncio Completo [Layer a Boton]");
        parent.eplSwapButton(this.getBannerId(), 1);
    };
    LayerBoton.prototype.adClose = function () {
        console.log("cerrar anuncio [Layer a Boton]");
        parent.eplSwapButton(this.getBannerId());
    };

    //Layer con Scroll
    function LayerScroll() {

    }
    LayerScroll.prototype = new LayerGenerico();
    LayerScroll.prototype.adComplete = function () {
        console.log("anuncio Completo [Layer con Scroll]");
        parent.eplDoc.eplTH.anuncioCompleto(this.getBannerId(), 1);
    };

    function AnuncioPrevio() {

    }
    AnuncioPrevio.prototype = new Ad();
    AnuncioPrevio.prototype.adComplete = function () {
        console.log("anuncio Completo [Anuncio Previo]");
        parent.eplHideLayer(this.getBannerId());
    };
    AnuncioPrevio.prototype.adClose = function () {
        console.log("cerrar anuncio [Anuncio Previo]");
        parent.eplPVExitLayer(this.getBannerId(), 1);
    };

    //Union de Layers
    function UnionLayers() {

    }
    UnionLayers.prototype = new Ad();
    UnionLayers.prototype.adComplete = function () {
        console.log("anuncio Completo [Union Layers]");
        parent.eplHideCenterLayer(this.getBannerId(), 1);
    };
    UnionLayers.prototype.adJoin = function () {
        console.log("join layers [Union Layers]");
        parent.eplJoinLayers(this.getBannerId());
    };
    UnionLayers.prototype.adClose = function () {
        console.log("cerrar anuncio [Union Layers]");
        parent.eplHideLeftRightLayers(this.getBannerId());
        parent.eplHideCenterLayer(this.getBannerId());
    };

    //Expandible Multiple
    function ExpandibleMultiple() {

    }
    ExpandibleMultiple.prototype = new Ad();
    ExpandibleMultiple.prototype.adComplete = function () {
        console.log("anuncio completo [Expandible Multiple]");
        parent.eplHBVShrinkLayer(this.getBannerId(), 1);
    };
    ExpandibleMultiple.prototype.adShrink = function () {
        console.log("replegar anuncio [Expandible Multiple]");
        parent.eplHBVShrinkLayer(this.getBannerId());
    };
    ExpandibleMultiple.prototype.adExpand = function () {
        console.log("expandir anuncio [Expandible Multiple]");
        parent.eplHBVExpandLayer(this.getBannerId());
    };

    function Folding() {
    }
    Folding.prototype = new ExpandibleMultiple();
    Folding.prototype.isAnimating = false;
    Folding.prototype.setImages = function(im1,im2,im3,im4,im5,im6){
        Folding.prototype.img1 = document.getElementById(im1);
        Folding.prototype.img2 = document.getElementById(im2);
        Folding.prototype.img3 = document.getElementById(im3);
        Folding.prototype.img4 = document.getElementById(im4);
        Folding.prototype.img5 = document.getElementById(im5);
        Folding.prototype.img6 = document.getElementById(im6);
    };
    Folding.prototype.initAnimation = function (fps) {
        if (!Folding.prototype.isAnimating) {
            Folding.prototype.isAnimating = true;
            Folding.prototype.img1.width = "0";
            Folding.prototype.img2.width = "0";
            Folding.prototype.img3.width = "0";
            Folding.prototype.img4.width = "0";
            Folding.prototype.img5.width = "0";
            Folding.prototype.img6.width = "0";
            var v = (typeof fps !== "undefined") ? parseInt(1000 / fps) : 24;
            function an(o) {
                console.log(o.id + " iniciado");
                var q = parseInt(o.width);
                var f = setInterval(function () {
                    q = q + 10;
                    o.width = q;
                    //console.log(q);
                    if (q >= 300) {
                        console.log(o.id + " terminado");
                        clearInterval(f);
                        document.body.dispatchEvent(new Event(o.id + "initEnded"));
                        return;
                    }
                }, v);
            }
            an(Folding.prototype.img1);
            document.body.addEventListener(Folding.prototype.img1.id + "initEnded", function () {
                an(Folding.prototype.img2);
            });
            document.body.addEventListener(Folding.prototype.img2.id + "initEnded", function () {
                an(Folding.prototype.img3);
            });
            document.body.addEventListener(Folding.prototype.img3.id + "initEnded", function () {
                an(Folding.prototype.img4);
            });
            document.body.addEventListener(Folding.prototype.img4.id + "initEnded", function () {
                an(Folding.prototype.img5);
            });
            document.body.addEventListener(Folding.prototype.img5.id + "initEnded", function () {
                an(Folding.prototype.img6);
            });
            document.body.addEventListener(Folding.prototype.img6.id + "initEnded", function () {
                Folding.prototype.isAnimating = false;
                console.log(Folding.prototype.isAnimating);
            });
        } else {
            console.log("Animando Folding.....espere");
        }

    };

    Folding.prototype.endAnimation = function (fps) {
        console.log(Folding.prototype.isAnimating);
        if (!Folding.prototype.isAnimating) {
            Folding.prototype.isAnimating = true;
            Folding.prototype.img1.width = "300";
            Folding.prototype.img2.width = "300";
            Folding.prototype.img3.width = "300";
            Folding.prototype.img4.width = "300";
            Folding.prototype.img5.width = "300";
            Folding.prototype.img6.width = "300";
            var v = (typeof fps !== "undefined") ? parseInt(1000 / fps) : 24;
            function an(o) {
                console.log(o.id + " iniciado");
                var q = parseInt(o.width);
                var f = setInterval(function () {
                    q = q - 10;
                    o.width = q;
                    //console.log(q);
                    if (q <= 0) {
                        console.log(o.id + " terminado");
                        clearInterval(f);
                        document.body.dispatchEvent(new Event(o.id + "ended"));
                        return;
                    }
                }, v);
            }
            an(Folding.prototype.img6);
            document.body.addEventListener(Folding.prototype.img6.id + "ended", function () {
                an(Folding.prototype.img5);
            });
            document.body.addEventListener(Folding.prototype.img5.id + "ended", function () {
                an(Folding.prototype.img4);
            });
            document.body.addEventListener(Folding.prototype.img4.id + "ended", function () {
                an(Folding.prototype.img3);
            });
            document.body.addEventListener(Folding.prototype.img3.id + "ended", function () {
                an(Folding.prototype.img2);
            });
            document.body.addEventListener(Folding.prototype.img2.id + "ended", function () {
                an(Folding.prototype.img1);
            });
            document.body.addEventListener(Folding.prototype.img1.id + "ended", function () {
                Folding.prototype.isAnimating = false;
                Folding.prototype.adComplete();
            });
        } else {
            console.log("Animando Folding.....espere");
        }

    };


    //Expandible Push
    function ExpandiblePush() {
    }
    ExpandiblePush.prototype = new Ad();
    ExpandiblePush.prototype.initExpanded = function () {
        if (typeof eplEBExpanded !== "undefined") {
            return eplEBExpanded;
        } else {
            console.log("Error: la variable eplEBExpanded no esta definida");
            return;
        }
    };
    ExpandiblePush.prototype.adShrink = function () {
        console.log("replegar anuncio [Expandible Push]");
        parent.eplEBShrinkLayer(this.getBannerId());
    };
    ExpandiblePush.prototype.adExpand = function () {
        console.log("expandir anuncio [Expandible Push]");
        parent.eplEBExpandLayer(this.getBannerId());
    };

    //Expandible Rollover
    function ExpandibleRollover() {

    }
    ExpandibleRollover.prototype = new Ad();
    ExpandibleRollover.prototype.adExpand = function () {
        console.log("expandir anuncio [Expandible Rollover]");
        parent.eplAMROExpandLayer(this.getBannerId());
    };
    ExpandibleRollover.prototype.adShrink = function () {
        console.log("replegar anuncio [Expandible Rollover]");
        parent.eplAMROShrinkLayer(this.getBannerId());
    };

    //Takeover
    function Takeover() {

    }
    Takeover.prototype = new Ad();
    Takeover.prototype.adComplete = function () {
        console.log("anuncio completo [Takeover]");
        parent.eplTOExitLayer(this.getBannerId(), 0);
    };
    Takeover.prototype.adClose = function () {
        console.log("cerrar anuncio [Takeover]");
        parent.eplTOExitLayer(this.getBannerId(), 1);
    };
    Takeover.prototype.adExpand = function () {
        console.log("expandir anuncio [Takeover]");
        parent.eplTORestartShow(this.getBannerId());
    };

    //Zocalo
    function Zocalo() {

    }
    Zocalo.prototype = new Ad();
    Zocalo.prototype.adComplete = function () {
        console.log("anuncio completo [Zocalo]");
        parent.eplZocaloShrink(1);
    };
    Zocalo.prototype.adExpand = function () {
        console.log("expandir anuncio [Zocalo]");
        parent.eplZocaloExpand(this.getBannerId());
    };
    Zocalo.prototype.adShrink = function () {
        console.log("replegar anuncio [Zocalo]");
        parent.eplZocaloShrink(0);
    };
    Zocalo.prototype.adClose = function () {
        console.log("cerrar anuncio [Zocalo]");
        parent.eplZocaloClose();
    };

    //Triple Impacto
    function TripleImpacto() {

    }
    TripleImpacto.prototype = new Ad();
    TripleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo [Triple Impacto]");
        parent.epl2BLHideLayer(this.getBannerId(), 1);
    };
    TripleImpacto.prototype.adShowLeft = function () {
        console.log("show left [Triple Impacto]");
        parent.epl2BLShowButton(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adShowRight = function () {
        console.log("show right [Triple Impacto]");
        parent.epl2BLShowBanner(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adShowLayer = function () {
        console.log("show layer [Triple Impacto]");
        parent.epl2BLShowLayer(this.getBannerId(), null);
    };

    TripleImpacto.prototype.adHideLeft = function () {
        console.log("hide left [Triple Impacto]");
        parent.epl2BLHideButton(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adHideRight = function () {
        console.log("hide right [Triple Impacto]");
        parent.epl2BLHideBanner(this.getBannerId(), null);
    };
    TripleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer [Triple Impacto]");
        parent.epl2BLHideLayer(this.getBannerId(), null);
    };

    //Multiple Impacto
    function MultipleImpacto() {

    }
    MultipleImpacto.prototype = new Ad();
    MultipleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo [Multiple Impacto]");
        parent.eplMIHideLayer(this.getBannerId(), 1);
    };
    MultipleImpacto.prototype.adShowLeft = function () {
        console.log("show left [Multiple Impacto]");
        parent.eplMIShowButton(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowRight = function () {
        console.log("show right [Multiple Impacto]");
        parent.eplMIShowTop(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowTop = function () {
        console.log("show top [Multiple Impacto]");
        parent.eplMIShowBanner(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adShowLayer = function () {
        console.log("show layer [Multiple Impacto]");
        parent.eplMIShowLayer(this.getBannerId(), null);
    };
    //
    MultipleImpacto.prototype.adHideLeft = function () {
        console.log("hide left [Multiple Impacto]");
        parent.eplMIHideButton(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideRight = function () {
        console.log("hide right [Multiple Impacto]");
        parent.eplMIHideTop(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideTop = function () {
        console.log("hide top [Multiple Impacto]");
        parent.eplMIHideBanner(this.getBannerId(), null);
    };
    MultipleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer [Multiple Impacto]");
        parent.eplMIHideLayer(this.getBannerId(), null);
    };

    //Quintuple Impacto
    function QuintupleImpacto() {

    }
    QuintupleImpacto.prototype = new Ad();
    QuintupleImpacto.prototype.adComplete = function () {
        console.log("anuncio completo [Quintuple Impacto]");
        parent.eplMIHideLayer(this.getBannerId(), 1);
    };
    QuintupleImpacto.prototype.adShowLeft = function () {
        console.log("show left [Quintuple Impacto]");
        parent.eplMI5ShowButton(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowRight = function () {
        console.log("show right [Quintuple Impacto]");
        parent.eplMI5ShowTop(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowTop = function () {
        console.log("show top [Quintuple Impacto]");
        parent.eplMI5ShowBanner(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowBottom = function () {
        console.log("show bottom [Quintuple Impacto]");
        parent.eplMI5ShowBox(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adShowLayer = function () {
        console.log("show layer [Quintuple Impacto]");
        parent.eplMI5ShowLayer(this.getBannerId(), null);
    };
    //
    QuintupleImpacto.prototype.adHideLeft = function () {
        console.log("hide left [Quintuple Impacto]");
        parent.eplMI5HideButton(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideRight = function () {
        console.log("hide right [Quintuple Impacto]");
        parent.eplMI5HideTop(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideTop = function () {
        console.log("hide top [Quintuple Impacto]");
        parent.eplMI5HideBanner(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideBottom = function () {
        console.log("hide bottom [Quintuple Impacto]");
        parent.eplMI5HideBox(this.getBannerId(), null);
    };
    QuintupleImpacto.prototype.adHideLayer = function () {
        console.log("hide layer [Quintuple Impacto]");
        parent.eplMI5HideLayer(this.getBannerId(), null);
    };

    //Inline
    function Inline() {
    }
    Inline.prototype = new Ad();
    Inline.prototype.setVideoInline = function (vid) {
        this.setVideo(vid);
        var v2 = this.getVideo(0);

        function eplSoundOn() {
            console.log("over inline");
            v2.muted = false;
            v2.volume = 1;
        }

        function eplSoundOff() {
            console.log("out inline");
            v2.volume = 0;
            v2.muted = true;
        }

        v2.onmouseover = function () {
            eplSoundOn();
        };

        v2.onmouseout = function () {
            eplSoundOff();
        };

    };

    //FORMATOS - fin

    //FACTORY - comienzo
    function adFactory() {
        this.formatosRegistrados = [];
    }
    adFactory.prototype.registrarFormato = function (id, formato) {
        this.formatosRegistrados[id] = formato;
    };
    adFactory.prototype.create = function (type) {
        return new this.formatosRegistrados[type];
    };

    //registro de clases de formatos al factory
    var factory = new adFactory();
    factory.registrarFormato(eplFormats.bannerGenerico, BannerGenerico);
    factory.registrarFormato(eplFormats.bannerSkin, BannerSkin);
    factory.registrarFormato(eplFormats.layerGenerico, LayerGenerico);
    factory.registrarFormato(eplFormats.bannerLayer, BannerLayer);
    factory.registrarFormato(eplFormats.layerBoton, LayerBoton);
    factory.registrarFormato(eplFormats.layerScroll, LayerScroll);
    factory.registrarFormato(eplFormats.anuncioPrevio, AnuncioPrevio);
    factory.registrarFormato(eplFormats.unionLayers, UnionLayers);
    factory.registrarFormato(eplFormats.expandibleMultiple, ExpandibleMultiple);
    factory.registrarFormato(eplFormats.folding, Folding);
    factory.registrarFormato(eplFormats.expandiblePush, ExpandiblePush);
    factory.registrarFormato(eplFormats.expandibleRollover, ExpandibleRollover);
    factory.registrarFormato(eplFormats.takeover, Takeover);
    factory.registrarFormato(eplFormats.zocalo, Zocalo);
    factory.registrarFormato(eplFormats.tripleImpacto, TripleImpacto);
    factory.registrarFormato(eplFormats.multipleImpacto, MultipleImpacto);
    factory.registrarFormato(eplFormats.quintupleImpacto, QuintupleImpacto);
    factory.registrarFormato(eplFormats.inline, Inline);
    //FACTORY - fin
    this.create = function (type) {
        return factory.create(type);
    };
}